how to get the variable in while loop outside of it?


 
Thread Tools Search this Thread
Top Forums Shell Programming and Scripting how to get the variable in while loop outside of it?
# 1  
Old 11-07-2011
how to get the variable in while loop outside of it?

bash-3.00$ cat compare.sh
#NOTE : 1.Filename must not have space for the script to work.
# 2.Script wont work if symlinks are there instead of proper filenames.

Code:
#!/bin/bash
#set -x

#############################VERIFYING THE EXISTENCE OF DUPLICATE FILENAMES IN THE SUPPLIED FILENAMES ###############

if [[ $# -lt 1 ]];then
echo "Usage : `basename $0` filename" 1>&2
exit 2
fi
awk '{f=$9;
        for(i=10;i<=NF;i++)
           f=f" "$i;
           d[f]++;
     }
END{
        for(f in d)
                if(d[f] > 1)
                 printf("file %s occurs %d times\n",f,d[f]);
                                                    }' `basename $1`
echo -e  "Please remove the dupliacte entries,\
\nkeep the file with the latest timestamp and check again"

################################CHECKING SIZE,DATE,TIME,FILENAME WITH THE EXISTING FILES############################

status=0
cat $1 | awk '{print $(NF-4),"\t",$(NF-3),"\t",$(NF-2),"\t",$(NF-1),"\t",$(NF)}' | \
while read size mon day time filename; do
    if [[ ! -f "$filename" ]]; then
        echo "ERROR: no such file: $filename" >&2
        status=1
    else
        filesize=$(ls -lrt "$filename" | awk '{print $5}')
        if [[ "$size" != "$filesize" ]]; then
            echo "ERROR: size mismatch: $filename" >&2
            status=1
        else
           # filetime=$(ls -lrt "$filename" | awk '{print $6," ",$7," ",$8}')
                actual_mon=$(ls -lrt "$filename" | awk '{print $6}')
                actual_day=$(ls -lrt "$filename" | awk '{print $7}')
                actual_time=$(ls -lrt "$filename" | awk '{print $8}')
            if [[ "$mon $day $time" != "$actual_mon $actual_day $actual_time" ]]; then
                echo "ERROR: date mismatch: $filename" >&2
                status=1
            fi
        fi
    fi
done
echo $status
if [[ "$status" -eq 0 ]];then
echo -e "\t\n\nSuccess! All the files are found and their size and timestamp is also matching with the existing files."
else
echo -e "\t\n\nFailure! Non-matching files are found or file doesn't exist."
fi


The value of status always remains 0.
How do i get the changed value from inside the while loop


On the other hand :
Code:
bash-3.00$ cat scope.sh
#!/bin/bash
x=0
while [[ "$x" -lt 10 ]];do
x=$(($x+1))
done
echo $x

here, the value of x changes to 10

why is this deviation.

Please help me i need to access the changed value in the first script but i am unable to do it.

Last edited by Franklin52; 11-07-2011 at 06:03 AM.. Reason: Please use code tags for data and code samples, thank you
# 2  
Old 11-07-2011
Code:
bash-3.00$ cat compare.sh
#NOTE : 1.Filename must not have space for the script to work.
#       2.Script wont work if symlinks are there instead of proper filenames.

#!/bin/bash
#set -x

#############################VERIFYING THE EXISTENCE OF DUPLICATE FILENAMES IN THE SUPPLIED FILENAMES ###############

if [[ $# -lt 1 ]];then
echo &quot;Usage : `basename $0` filename&quot; 1>&2
exit 2
fi
awk '{f=$9;
        for(i=10;i<=NF;i++)
           f=f&quot; &quot;$i;
           d[f]++;
     }
END{
        for(f in d)
                if(d[f] > 1)
                 printf(&quot;file %s occurs %d times\n&quot;,f,d[f]);
                                                    }' `basename $1`
echo -e  &quot;Please remove the dupliacte entries,\
\nkeep the file with the latest timestamp and check again&quot;

################################CHECKING SIZE,DATE,TIME,FILENAME WITH THE EXISTING FILES############################

status=0
cat $1 | awk '{print  $(NF-4),&quot;\t&quot;,$(NF-3),&quot;\t&quot;,$(NF-2),&quot;\t&quot;,$(NF-1),&quot;\t&quot;,$(NF)}'  | \
while read size mon day time filename; do
    if [[ ! -f &quot;$filename&quot; ]]; then
        echo &quot;ERROR: no such file: $filename&quot; >&2
        status=1
    else
        filesize=$(ls -lrt &quot;$filename&quot; | awk '{print $5}')
        if [[ &quot;$size&quot; != &quot;$filesize&quot; ]]; then
            echo &quot;ERROR: size mismatch: $filename&quot; >&2
            status=1
        else
           # filetime=$(ls -lrt &quot;$filename&quot; | awk  '{print $6,&quot; &quot;,$7,&quot; &quot;,$8}')
                actual_mon=$(ls -lrt &quot;$filename&quot; | awk '{print $6}')
                actual_day=$(ls -lrt &quot;$filename&quot; | awk '{print $7}')
                actual_time=$(ls -lrt &quot;$filename&quot; | awk '{print $8}')
            if [[ &quot;$mon $day $time&quot; != &quot;$actual_mon $actual_day $actual_time&quot; ]]; then
                echo &quot;ERROR: date mismatch: $filename&quot; >&2
                status=1
            fi
        fi
    fi
done
echo $status
if [[ &quot;$status&quot; -eq 0 ]];then
echo -e &quot;\t\n\nSuccess! All the files are found and their size  and timestamp is also matching with the existing files.&quot;
else
echo -e &quot;\t\n\nFailure! Non-matching files are found or file doesn't exist.&quot;
fi

Check out Variable Scope in Bash (NuclearDonkey.net) for one of several possible solutions here. Essentially, the issue is that you're modifying variables in a sub-process. You'll either need some inter-process trickery, or you'll have to modify your code to eliminate the direct use of the pipeline.

Also, please use [code] tags, as they make things much, much easier to read.
This User Gave Thanks to BMDan For This Post:
# 3  
Old 11-07-2011
This is an issue caused with the way bash implements pipes. When piping input to a while, I believe that bash executed the while in a child processes which causes any changes to variables inside of the while to be lost.


This is one reason I prefer kshell over bash. If you have a modern kshell, I suggest you use it. If not then try writing your output to a temp file and reading it into the while.
Code:
x=0
ls | while read f
do
    x=$(( $x + 1 ))
    printf "in loop: $x\n"
done
printf "after loop: $x\n"

 ls >/tmp/ls
x=0

 while read f
do
    x=$(( $x + 1 ))
    printf "in loop: $x\n"
done </tmp/ls
printf "after second loop: $x\n"

Try this in both shells to see the difference. Ksh gets the answer right after the loop both times.

Last edited by agama; 11-07-2011 at 12:45 AM.. Reason: typo
# 4  
Old 11-07-2011
Here is a little BASH trick to avoid these problems...
Code:
#!/bin/bash

function myLoop()
{
  echo $1 |
  while read WORD
  do
    echo $WORD|egrep "[0-9]" 2>/dev/null 1>/dev/null
    RETVAL=$?

    echo "Something to the screen..." >&2
    echo $RETVAL
  done
}

echo RETVAL=$(myLoop $1)

The basic idea is to echo the value as a function output. This output can then be captured as whatever variable you want.
This User Gave Thanks to jjinno For This Post:
Login or Register to Ask a Question

Previous Thread | Next Thread

10 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

[Solved] How to increment and add variable length numbers to a variable in a loop?

Hi All, I have a file which has hundred of records with fixed number of fields. In each record there is set of 8 characters which represent the duration of that activity. I want to sum up the duration present in all the records for a report. The problem is the duration changes per record so I... (5 Replies)
Discussion started by: danish0909
5 Replies

2. Shell Programming and Scripting

Array Variable being Assigned Values in Loop, But Gone when Loop Completes???

Hello All, Maybe I'm Missing something here but I have NOOO idea what the heck is going on with this....? I have a Variable that contains a PATTERN of what I'm considering "Illegal Characters". So what I'm doing is looping through a string containing some of these "Illegal Characters". Now... (5 Replies)
Discussion started by: mrm5102
5 Replies

3. UNIX for Dummies Questions & Answers

Loop and variable not exactly variable: what's wrong

Hello guys, This truly is a newbie question. I'm trying to make a loop to execute simultaneous commands indefinitely while using variable. Here is how my mess looks like (this is just an example): #!/bin/bash IP=`shuf -n 1 IP.txt` # I figured this would be easier to select random lines... (4 Replies)
Discussion started by: bobylapointe
4 Replies

4. Shell Programming and Scripting

printing variable with variable suffix through loop

I have a group of variables myLINEcnt1 - myLINEcnt10. I'm trying to printout the values using a for loop. I am at the head banging stage since i'm sure it has to be a basic syntax issue that i can't figure out. For myIPgrp in 1 2 3 4 5 6 7 8 9 10; do here i want to output the value of... (4 Replies)
Discussion started by: oly_r
4 Replies

5. Shell Programming and Scripting

[SHELL: /bin/sh] For loop using variable variable names

Simple enough problem I think, I just can't seem to get it right. The below doesn't work as intended, it's just a function defined in a much larger script: CheckValues() { for field in \ Group_ID \ Group_Title \ Rule_ID \ Rule_Severity \ ... (2 Replies)
Discussion started by: Vryali
2 Replies

6. Shell Programming and Scripting

For loop with one variable as the name of other

Hello all, I find it hard to explain what I need so I will post the code OVZINCLUDE="16810 16811 1689" PLUS_16810="test" PLUS_16811="test" for VPS in $OVZINCLUDE do echo "Dumping VPSes: $OVZINCLUDE " vzdump --compress --snapshot ${PLUS_$VPS} $VPS done ... (2 Replies)
Discussion started by: click
2 Replies

7. Shell Programming and Scripting

Help with variable using loop

Hi I have webserver that I do read data from. Data are stored like this: Huston |1 Portland |2 Hazen |1 Minneapolis |4 Albany |1 Pittsburg |1 Albany |1 Huston |1 Portland|1 Hazen |2 Albany |2 Huston |1 Hazen |1 Script #!/bin/sh user="admin" (1 Reply)
Discussion started by: Jotne
1 Replies

8. Shell Programming and Scripting

For loop Variable

Hi, Is it possible to assign one variable to other. eg. v1="table1" v2="20000" I want table1 to assign 20000 table1=20000 Is there any way? Thanks (2 Replies)
Discussion started by: SushilM
2 Replies

9. Shell Programming and Scripting

loop through variable

i have these data in a variable "$test" BUNGA TERATAI 3 5055 ITH 1 1 JADE TRADER 143W ITH 4 4 MOL SPLENDOR 0307A ITH 3 3 the red coloured are the ones that i want to take and compare what I need to do is to take out the red coloured and then compare to another variable, if same then... (0 Replies)
Discussion started by: finalight
0 Replies

10. Shell Programming and Scripting

variable in a for loop

Hi... i am trying to ping my servers .The hostnames are present in a file .They are separated by spaces in the file . i am doing the following : a=1 for name in $(cat host2 |cut -d" " -f$a) do echo Pinging server $name ping -c5 $name a=$a+1 done It is... (3 Replies)
Discussion started by: sars
3 Replies
Login or Register to Ask a Question